VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CUser"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public WithEvents Socket As CSocket
Attribute Socket.VB_VarHelpID = -1
Public Nickname As String
Public RemoteHostIP As String
Public Handle As Long

Private Sub Class_Initialize()
    Set Socket = New CSocket
End Sub

Public Sub Socket_Closed()
Dim User As CUser
    frmMain.Users.Remove CStr(Handle)
    If Nickname <> "" Then
        ' Notify other users of quit
        For Each User In frmMain.Users
            If User.Nickname <> "" Then User.Socket.SendData "Q " & Nickname
        Next
        frmMain.lstNames.RemoveItem GetItemNum(Nickname)
        If frmMain.lstNames.ListCount = 1 Then frmMain.txtTalk.Locked = True
        If frmMain.txtChat <> "" Then frmMain.txtChat = frmMain.txtChat & vbCrLf
        frmMain.txtChat = frmMain.txtChat & "* " & Nickname & " (" & RemoteHostIP & ") has left the chat"
        frmMain.txtChat.SelStart = Len(frmMain.txtChat)
    End If
End Sub

Private Sub Socket_LineDataArrival(LineData As String, RemoteHostIP As String)
Dim Comnd As String
Dim Data As String
Dim User As CUser
    Comnd = Left$(LineData, InStr(LineData, " ") - 1)
    Data = Mid$(LineData, Len(Comnd) + 2)
    Select Case Comnd
        Case "C"
            If GetItemNum(Data) > -1 Or Data = frmMain.txtNickname Then
                ' Nickname in use
                Socket.SendData "N "
                Exit Sub
            End If
            If frmMain.chkAuthorize.Value Then
                If MsgBox("Do you want to accept a connection from " & RemoteHostIP & " ?", vbYesNo, "Connection Request") = vbNo Then
                    ' No Accept
                    Socket.SendData "A "
                    Exit Sub
                End If
            End If
            Nickname = Data
            ' Notify other users of Connect and user of other users
            Socket.SendData "SJ @" & frmMain.txtNickname
            For Each User In frmMain.Users
                If Not User Is Me Then
                    User.Socket.SendData "J " & Data & " " & RemoteHostIP
                    Socket.SendData "SJ " & User.Nickname & " " & User.RemoteHostIP
                End If
            Next
            ' Add name to nicks list
            frmMain.lstNames.AddItem Data
            If frmMain.txtChat <> "" Then frmMain.txtChat = frmMain.txtChat & vbCrLf
            frmMain.txtChat = frmMain.txtChat & "* " & Data & " (" & RemoteHostIP & ") has joined the chat"
            frmMain.txtChat.SelStart = Len(frmMain.txtChat)
            frmMain.txtTalk.Locked = False
        Case "T" ' Talk
            ' Send data to other users
            For Each User In frmMain.Users
                If Not User Is Me And User.Nickname <> "" Then User.Socket.SendData "T " & Nickname & " " & Data
            Next
            If frmMain.txtChat <> "" Then frmMain.txtChat = frmMain.txtChat & vbCrLf
            If LCase$(Left$(Data, 4)) = "/me " Then
                ' Action
                frmMain.txtChat = frmMain.txtChat & "* " & Nickname & Mid$(Data, 4)
            Else
                ' Statement
                frmMain.txtChat = frmMain.txtChat & "<" & Nickname & "> " & Data
            End If
            frmMain.txtChat.SelStart = Len(frmMain.txtChat)
     End Select
End Sub
